if(isPackage("FlyMode"))
{
	deactivatePackage("FlyMode");
}

package FlyMode
{
	function Armor::onTrigger(%this, %obj, %slot, %down)
	{
		if(%obj.isInFlyMode)
		{
			if(%slot == 3)
			{
				%obj.FlyMode_Down(%down);
			}
			if(%slot == 2)
			{
				%obj.FlyMode_Up(%down);
			}
		}
		if(%slot == 4 && %down)
		{
			if($Sim::Time - %obj.FlyMode_LastRightClick < 0.25)
			{
				serverCmdFly(%obj.client);
			}
			else if(%obj.isInFlyMode)
			{
				%obj.setVelocity(0 SPC 0 SPC getWord(%this.getVelocity(), 2));
			}
			%obj.FlyMode_LastRightClick = $Sim::Time;
		}
		Parent::onTrigger(%this, %obj, %slot, %down);
	}
};

activatePackage("FlyMode");

function serverCmdFly(%this)
{
	if($Pref::Server::FlyMode::AdminOnly && !%this.isAdmin)
	{
		messageClient(%this, '', 'Flying restrictions are set to \c3Admin Only\c0.');
		return;
	}
	
	%player = %this.player;
	if(!isObject(%player))
	{
		return;
	}
	
	%player.isInFlyMode = !%player.isInFlyMode;
	%player.setArmThread(%player.isInFlyMode ? "crouch" : "look");
	
	if(%player.isInFlyMode)
	{
		%player.FlyMode_Neutral();
	}
	else
	{
		cancel(%player.FlyMode_Neutral);
		cancel(%player.FlyMode_Down);
		cancel(%player.FlyMode_Up);
	}
	%player.playThread(0, "plant");
}

function serverCmdAdminFly(%this)
{
	if(!%this.isSuperAdmin)
	{
		messageClient(%this, '', 'You must be \c3Super Admin\c0 to change server settings.');
		return;
	}

	if(!$Pref::Server::FlyMode::AdminOnly)
	{
		FlyMode_StopNoobs();
	}

	$Pref::Server::FlyMode::AdminOnly = !$Pref::Server::FlyMode::AdminOnly;

	messageAll('MsgAdminForce', '\c3%1 \c0set flying restrictions to \c3%2\c0.', %this.name, $Pref::Server::FlyMode::AdminOnly ? "Admin Only" : "Everybody");
}

function FlyMode_StopNoobs()
{
	for(%a = 0; %a < ClientGroup.getCount(); %a++)
	{
		%client = ClientGroup.getObject(%a);
		%obj = %client.player;

		if(!isObject(%obj))
		{
			continue;
		}

		if(!%client.isAdmin && %obj.isInFlyMode)
		{
			serverCmdFly(%client);
		}
	}
}

function Player::FlyMode_Neutral(%this, %down)
{
	%this.setVelocity(getWords(%this.getVelocity(), 0, 1) SPC "0.66");
	
	%this.FlyMode_Neutral = %this.schedule(2, FlyMode_Neutral, 1);
}

function Player::FlyMode_Down(%this, %down)
{
	if(!%down)
	{
		cancel(%this.FlyMode_Down);
		return;
	}
	
	%this.setVelocity(getWords(%this.getVelocity(), 0, 1) SPC "-3");
	
	%this.FlyMode_Down = %this.schedule(2, FlyMode_Down, 1);
}

function Player::FlyMode_Up(%this, %down)
{
	if(!%down)
	{
		cancel(%this.FlyMode_Up);
		return;
	}
	
	%this.setVelocity(getWords(%this.getVelocity(), 0, 1) SPC "3.66");
	
	%this.FlyMode_Up = %this.schedule(2, FlyMode_Up, 1);
}